program_description = """ This program splits an input fasta 
file into n files, balanced by sequence length.  The input 
filename should have an extension of some sort (e.g. 
'*.fasta' or '*.fna').  The output files will be named 
(*.p1.fasta, *.p2.fasta,...*.pn.fasta)

usage:  splitfasta.py <fastafilename> <n>
"""

import sys,heapq
path = '..'
if not path in sys.path:
   sys.path.append(path)

from rita.core.fastaio import FastaIO

print program_description

filename = sys.argv[1]
n = int(sys.argv[2])


parts = filename.split('.')
root,extension = '.'.join(parts[:-1]), parts[-1]

files = []

for i in range(n):
   name = '%s.p%d.%s'%(root,i+1,extension)
   heapq.heappush(files,[0,open(name,'w')])
fio = FastaIO()
seqs = list(fio.read(filename))

for i,(seqid,seq) in enumerate(seqs):
   size,f = heapq.heappop(files)
   size += len(seq)
   f.write('>%s\n%s\n'%(seqid,seq))
   heapq.heappush(files,(size,f))
for i in range(n):
   files[i][1].close()

